﻿using System.Web.Mvc;
using Kreta.BusinessLogic.Security;
using Kreta.Web.Areas.Tanulo.Models;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.Tanulo.Controllers
{
    [MvcRoleClaimsAuthorize(true)]
    [MvcRolePackageAuthorize(KretaClaimPackages.Tanar.ClaimValue)]
    public class TanarTanitottTanulokController : Controller
    {
        public ActionResult Index(bool? csakBukasraAllok = null)
        {
            var model = new TanarTanitottTanulokSearchModel
            {
                CsakBukasraAllok = csakBukasraAllok ?? false,
                EnableRowFunctions = ClaimData.FelhasznaloSzerepCsomagok.Contains(KretaClaimPackages.FelhasznaloMunkakoreNemTiltoListas.ClaimValue)
            };

            return View("Index", model);
        }

        public ActionResult OpenStartPopup()
        {
            var model = new TanarTanitottTanulokStartPopUpModel();
            return PartialView("Start_Popup", model);
        }
    }
}
